
.include "m32def.inc"     // Includem fisirul 

; definirea unei constante
 .equ MCU_FREQ	=   10000000

; redefinirea registrilor
 .def tmpL  = r16
 .def tmpH  = r17
 .def aL 	= r18
 .def aH 	= r19

 .def flags = r2

 

.dseg	; segmentul de date
.org 0x62
variabila: .BYTE 1



.cseg	; segmentul de cod 
.org	0x0000
	rjmp	Reset	; Salt neconditionat

.org	INT0addr	; External Interrupt0 Vector Address
	reti
.org	INT1addr	; External Interrupt1 Vector Address
	rjmp INT1_ISR

.org	INT2addr	; External Interrupt2 Vector Address
	reti
.org	OC2addr	    ; Output Compare2 Interrupt Vector Address
	reti 
.org	OVF2addr	; Overflow2 Interrupt Vector Address
	reti
.org	ICP1addr	; Input Capture1 Interrupt Vector Address
	reti
.org	OC1Aaddr	; Output Compare1A Interrupt Vector Address
	reti
.org	OC1Baddr	; Output Compare1B Interrupt Vector Address
	reti
.org	OVF1addr	; Overflow1 Interrupt Vector Address
	reti
.org	OC0addr	    ; Output Compare0 Interrupt Vector Address
	reti
.org	OVF0addr	; Overflow0 Interrupt Vector Address
	reti
.org	SPIaddr	     ; SPI Interrupt Vector Address
	reti
.org	URXCaddr	; USART Receive Complete Interrupt Vector Address
	reti
.org	UDREaddr	; USART Data Register Empty Interrupt Vector Address
	reti
.org	UTXCaddr	; USART Transmit Complete Interrupt Vector Address
	reti
.org	ADCCaddr	; ADC Interrupt Vector Address
	reti
.org	ERDYaddr	; EEPROM Interrupt Vector Address
	reti
.org	ACIaddr 	; Analog Comparator Interrupt Vector Address
	reti
.org    TWIaddr   ; Irq. vector address for Two-Wire Interface
	reti
.org	SPMRaddr	; Store Program Memory Ready Interrupt Vector Address
	reti

//---------------------------------------------------------------
INT1_ISR:    ;Subrutina de prelucrare a intreruperii
	in flags, SREG		; memorizam temporar flagurile
 		; comenzi pentru subruta data

		
	 out SREG, flags	; restabilim fanioanele
	 reti

; Programul principal
//--------------------------------------------------------------	 
RESET:
	// Initilizam StackPointer - la ultima adresa de memorie RAM	 
     ldi tmpL, Low(RAMEND) 	; initializam stiva
	 out SPL, tmpL
	 ldi tmpH, High(RAMEND) 
	 out SPH, tmpH

 	// Initializam periferia de care avem nevoie : Porturi, timere, contr. de intreruperi.....




	 CLR tmpL				;resetam tmpl
	 out DDRB, tmpL			; Setam ca intrare PORTA

	 ldi tmpL, 0xff
	 out DDRC, tmpL
	 out DDRA, tmpL


/*
	 ldi tmpL, 0xff			 	
	 out DDRB, tmpL			; Setam ca iesire PORTB	 
	 out DDRC, tmpL			; Setam ca iesire PORTC
*/	


	/*
	PORTA = 0xff;


	ldi R0, 0xFF
	out PORTA, R0


	SBI PORTC, 3

	PORTC |= (1<<3); 
	*/

 MAIN: ; programul principal
 	// bucla infinita
	
	in tmpL, PINB
	ldi aL, 2
	mul aL, tmpL

	lds tmpL, 0x62
	asr tmpL
	asr tmpL
	ldi tmpH, 0

	sub tmpL, R0
	sbc tmpH, R1

	ldi aL, 4
loop_div16:
	asr tmpH
	ror tmpL
	
	dec aL
	brne loop_div16

		
	out PORTA, tmpL
	out PORTC, tmpH
	
	RJMP MAIN


